package com.zcloud.modules.kangzai.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zcloud.common.utils.PageUtils;
import com.zcloud.modules.kangzai.dao.BusGeologicalDisasterDao;
import com.zcloud.modules.kangzai.entity.BusGeologicalDisasterEntity;
import com.zcloud.modules.kangzai.service.BusGeologicalDisasterService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.List;
import java.util.Map;

/**
 * @Author fangjiakai
 * @Desc 地质灾害点信息详情表(BusGeologicalDisaster)表服务实现类
 * @Date 2025-06-09 10:14:59
 */
@Service("busGeologicalDisasterService")
public class BusGeologicalDisasterServiceImpl extends ServiceImpl<BusGeologicalDisasterDao, BusGeologicalDisasterEntity> implements BusGeologicalDisasterService {

    @Override
    public BusGeologicalDisasterEntity queryByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusGeologicalDisasterEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectOne(queryWrapper);
    }

    @Override
    public List<BusGeologicalDisasterEntity> queryListByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusGeologicalDisasterEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectList(queryWrapper);
    }

    @Override
    public PageUtils listPage(Map<String, Object> params) {
        Page<Map<String, Object>> page = new Page<>(Integer.parseInt(params.get("curPage").toString()), Integer.parseInt(params.get("limit").toString()));
        params.put("isDelete", 0);
        IPage<BusGeologicalDisasterEntity> ipage = baseMapper.listPage(page, params);
        return new PageUtils(ipage);
    }


    @Override
    public void delete(String geologicalDisasterId, String userId) {
        UpdateWrapper<BusGeologicalDisasterEntity> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("geological_disaster_id", geologicalDisasterId);

        BusGeologicalDisasterEntity busGeologicalDisaster = new BusGeologicalDisasterEntity();
        busGeologicalDisaster.setOperator(userId);
        busGeologicalDisaster.setIsDelete(1);

        this.update(busGeologicalDisaster, updateWrapper);
    }
}
